﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Data;
using System.Reflection;

//Progetto realizzato da Ing. Maltraversi Marco: maltra@tin.it  http://www.futuresoftware.it e  http://www.ingegneridelweb.com
// Il contenuto di questo progetto  è pubblicato sotto una Licenza Creative Commons : http://creativecommons.org/licenses/by-nc-sa/2.5/it/


namespace CL_Adapter
{   
    public class AdapterLinq
    {
        // ATTRIBUTI
        // elemento corrispondente alla mappatura
        DataClassLinqDataContext db = new DataClassLinqDataContext();

        //////////////////////////////////////////////////////////

        // COSTRUTTORE
        public AdapterLinq() {

        }

        //////////////////////////////////////////////////////////

        // METODI
        #region ConversioneDaIEnumerableADataTable
        public DataTable ObtainDataTableFromIEnumerable(System.Collections.IEnumerable p_ien)
        {
            // creazione di una DataTable vuota
            DataTable dt = new DataTable();

            // per tutti gli elementi presenti nell'IEnumerable passato come parametro
            foreach (object obj in p_ien)
            {
                // determinazione di classe e proprieta' dell'oggetto
                Type t = obj.GetType();
                PropertyInfo[] pis = t.GetProperties();

                // riempimento dei nomi delle colonne
                if (dt.Columns.Count == 0)
                {
                    foreach (PropertyInfo pi in pis)
                    {
                        dt.Columns.Add(pi.Name, pi.PropertyType);
                    } // end foreach
                } // end if

                // creazione di una nuova riga
                DataRow dr = dt.NewRow();

                // per tutti gli oggetti
                foreach (PropertyInfo pi in pis)
                {
                    // inserimento del valore degli oggetti stessi               
                    object value = pi.GetValue(obj, null);
                    dr[pi.Name] = value;
                } // end foreach 

                // aggiunta della nuova riga alla lista delle righe in dt
                dt.Rows.Add(dr);

            } // end foreach object in p_ien

            // ritorno della data table
            return dt;

        } // end method ObtainDataTableFromIEnumerable
        #endregion

        #region CaricamentoParzialeDelRecord
        //Carica Solo Il Nome Cognome e Id Dell'utente Con Linq
        public DataTable GetData()
        {
            // estrazione di dati con LINQ
            var results = from c in db.Clientis
                          select new {c.Id, c.Cognome, c.Nome };

            // ritorna l'elemento convertito in DataTable
            return  ObtainDataTableFromIEnumerable(results);          
        } // end method GetData
        #endregion

        #region CaricamentoTotaleDelRecord
        //Carica tutti i dati, ovvero tutto il record
        public DataTable GetFullData()
        {

            var results = from c in db.Clientis
                          select new { c.Id, c.Cognome, c.Nome, c.Indirizzo, c.Cap, c.Citta, c.Tipologia };

            // ritorna l'elemento convertito in DataTable
            return ObtainDataTableFromIEnumerable(results); //dt; //Ritorna La Data Table
        } // end method GetFullData
        #endregion

        #region CaricamentoParzialeDelRecordPerID
        //Seleziona l'utente con un determinato id
        public DataTable GetDataByID(int p_id)
        {
            var results = from c in db.Clientis
                          where c.Id.Equals(p_id)
                          select new { c.Id, c.Cognome, c.Nome };

            // ritorna l'elemento convertito in DataTable
            return ObtainDataTableFromIEnumerable(results); //dt; //Ritorno La Data Table
        } // end method GetDataByID
        #endregion

    } // end class AdapterLinq

} // end namespace CL_Adapter
